Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -9837,27 +10097,25 @@
                       DO  k = nzb_do, nzt_do
                          temp_bin = 0.0_wp
-                         DO  c = ( icc-1 )*nbins+1, icc*nbins                          
-                            temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                         DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
+                            temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                          ENDDO
-                         local_pf(i,j,k) = MERGE( temp_bin,                    &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                         local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = wp ),         &
+                                                  BTEST( wall_flags_0(k,j,i), 0 ) ) 
                       ENDDO
                    ENDDO
                 ENDDO
              ELSE
-                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_BC_av
-                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_DU_av   
-                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_NH_av   
-                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_NO_av   
-                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_OC_av   
-                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_SO4_av   
-                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_SS_av 
+                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_bc_av
+                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_du_av
+                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_nh_av
+                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_no_av
+                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_oc_av
+                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_so4_av
+                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_ss_av
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      DO  k = nzb_do, nzt_do                      
-                         local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),       &
-                                               REAL( fill_value, KIND = wp ),  &
-                                               BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                      DO  k = nzb_do, nzt_do
+                         local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i), REAL( fill_value,         &
+                                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) )
                       ENDDO
                    ENDDO
@@ -9865,4 +10123,5 @@
              ENDIF
           ENDIF
+
        CASE DEFAULT
           found = .FALSE.
@@ -9879,32 +10138,32 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE salsa_data_output_mask( av, variable, found, local_pf )
- 
-    USE arrays_3d,                                                             &
+
+    USE arrays_3d,                                                                                 &
         ONLY:  tend
- 
-    USE control_parameters,                                                    &
+
+    USE control_parameters,                                                                        &
         ONLY:  mask_size_l, mask_surface, mid
-        
-    USE surface_mod,                                                           &
-        ONLY:  get_topography_top_index_ji       
- 
+
+    USE surface_mod,                                                                               &
+        ONLY:  get_topography_top_index_ji
+
     IMPLICIT NONE
-    
+
     CHARACTER(LEN=5) ::  grid      !< flag to distinquish between staggered grid
-    CHARACTER(LEN=*) ::  variable  !< 
+    CHARACTER(LEN=*) ::  variable  !<
     CHARACTER(LEN=7) ::  vari      !< trimmed format of variable
 
-    INTEGER(iwp) ::  av              !< 
-    INTEGER(iwp) ::  b               !< loop index for aerosol size number bins
-    INTEGER(iwp) ::  c               !< loop index for chemical components
+    INTEGER(iwp) ::  av              !<
+    INTEGER(iwp) ::  found_index     !< index of a chemical compound
+    INTEGER(iwp) ::  ib              !< loop index for aerosol size number bins
+    INTEGER(iwp) ::  ic              !< loop index for chemical components
     INTEGER(iwp) ::  i               !< loop index in x-direction
-    INTEGER(iwp) ::  icc             !< index of a chemical compound
     INTEGER(iwp) ::  j               !< loop index in y-direction
     INTEGER(iwp) ::  k               !< loop index in z-direction
     INTEGER(iwp) ::  topo_top_ind    !< k index of highest horizontal surface
-    
-    LOGICAL ::  found      !< 
+
+    LOGICAL ::  found      !<
     LOGICAL ::  resorted   !<
-    
+
     REAL(wp) ::  df        !< For calculating LDSA: fraction of particles 
                            !< depositing in the alveolar (or tracheobronchial)
@@ -9912,8 +10171,8 @@
     REAL(wp) ::  mean_d    !< Particle diameter in micrometres
     REAL(wp) ::  nc        !< Particle number concentration in units 1/cm**3
-    REAL(wp) ::  temp_bin  !< temporary array for calculating output variables    
-
-    REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  local_pf   !< 
-    
+    REAL(wp) ::  temp_bin  !< temporary array for calculating output variables
+
+    REAL(wp), DIMENSION(mask_size_l(mid,1),mask_size_l(mid,2),mask_size_l(mid,3)) ::  local_pf   !<
+
     REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< pointer
 
@@ -9924,5 +10183,5 @@
 
     SELECT CASE ( TRIM( variable ) )
-    
+
        CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV' )
           vari = TRIM( variable )
@@ -9932,13 +10191,13 @@
              IF ( vari == 'g_NH3')    to_be_resorted => salsa_gas(3)%conc
              IF ( vari == 'g_OCNV')   to_be_resorted => salsa_gas(4)%conc
-             IF ( vari == 'g_OCSV')   to_be_resorted => salsa_gas(5)%conc 
+             IF ( vari == 'g_OCSV')   to_be_resorted => salsa_gas(5)%conc
           ELSE
-             IF ( vari == 'g_H2SO4') to_be_resorted => g_H2SO4_av
-             IF ( vari == 'g_HNO3')  to_be_resorted => g_HNO3_av   
-             IF ( vari == 'g_NH3')   to_be_resorted => g_NH3_av   
-             IF ( vari == 'g_OCNV')  to_be_resorted => g_OCNV_av   
-             IF ( vari == 'g_OCSV')  to_be_resorted => g_OCSV_av
+             IF ( vari == 'g_H2SO4') to_be_resorted => g_h2so4_av
+             IF ( vari == 'g_HNO3')  to_be_resorted => g_hno3_av
+             IF ( vari == 'g_NH3')   to_be_resorted => g_nh3_av
+             IF ( vari == 'g_OCNV')  to_be_resorted => g_ocnv_av
+             IF ( vari == 'g_OCSV')  to_be_resorted => g_ocsv_av
           ENDIF
-          
+
        CASE ( 'LDSA' )
           IF ( av == 0 )  THEN
@@ -9947,20 +10206,19 @@
                    DO  k = nzb, nz_do3d
                       temp_bin = 0.0_wp
-                      DO  b = 1, nbins
-!                      
+                      DO  ib = 1, nbins_aerosol
+!
 !--                      Diameter in micrometres
-                         mean_d = 1.0E+6_wp * Ra_dry(k,j,i,b) * 2.0_wp
-!                               
-!--                      Deposition factor: alveolar                                
-                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp *     &
-                              ( LOG( mean_d ) + 2.84_wp )**2.0_wp ) + 19.11_wp &
-                              * EXP( -0.482_wp * ( LOG( mean_d ) - 1.362_wp    &
-                                )**2.0_wp ) )
-!                                    
+                         mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
+!
+!--                      Deposition factor: alveolar
+                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +       &
+                                2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -     &
+                                1.362_wp )**2 ) )
+!
 !--                      Number concentration in 1/cm3
-                         nc = 1.0E-6_wp * aerosol_number(b)%conc(k,j,i)
-!                         
+                         nc = 1.0E-6_wp * aerosol_number(ib)%conc(k,j,i)
+!
 !--                      Lung-deposited surface area LDSA (units mum2/cm3)
-                         temp_bin = temp_bin + pi * mean_d**2.0_wp * df * nc 
+                         temp_bin = temp_bin + pi * mean_d**2 * df * nc
                       ENDDO
                       tend(k,j,i) = temp_bin
@@ -9972,6 +10230,5 @@
                    DO  j = 1, mask_size_l(mid,2)
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
-                                                 mask_i(mid,i) )
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
                    ENDDO
@@ -9980,10 +10237,8 @@
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
-                                                                  mask_i(mid,i),&
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
                                                                   grid )
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
-                                                      nzt+1 ),                 &
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
                                                  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
@@ -9993,44 +10248,41 @@
              resorted = .TRUE.
           ELSE
-             to_be_resorted => LDSA_av
+             to_be_resorted => ldsa_av
           ENDIF
-          
-       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',   'N_bin5',  'N_bin6',   &
-              'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10' , 'N_bin11', 'N_bin12' )
-          IF ( TRIM( variable(6:) ) == '1' ) b = 1
-          IF ( TRIM( variable(6:) ) == '2' ) b = 2
-          IF ( TRIM( variable(6:) ) == '3' ) b = 3
-          IF ( TRIM( variable(6:) ) == '4' ) b = 4
-          IF ( TRIM( variable(6:) ) == '5' ) b = 5
-          IF ( TRIM( variable(6:) ) == '6' ) b = 6
-          IF ( TRIM( variable(6:) ) == '7' ) b = 7
-          IF ( TRIM( variable(6:) ) == '8' ) b = 8
-          IF ( TRIM( variable(6:) ) == '9' ) b = 9
-          IF ( TRIM( variable(6:) ) == '10' ) b = 10
-          IF ( TRIM( variable(6:) ) == '11' ) b = 11
-          IF ( TRIM( variable(6:) ) == '12' ) b = 12
-          
+
+       CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',   'N_bin5',  'N_bin6', 'N_bin7', 'N_bin8',   &
+              'N_bin9', 'N_bin10' , 'N_bin11', 'N_bin12' )
+          IF ( TRIM( variable(6:) ) == '1' ) ib = 1
+          IF ( TRIM( variable(6:) ) == '2' ) ib = 2
+          IF ( TRIM( variable(6:) ) == '3' ) ib = 3
+          IF ( TRIM( variable(6:) ) == '4' ) ib = 4
+          IF ( TRIM( variable(6:) ) == '5' ) ib = 5
+          IF ( TRIM( variable(6:) ) == '6' ) ib = 6
+          IF ( TRIM( variable(6:) ) == '7' ) ib = 7
+          IF ( TRIM( variable(6:) ) == '8' ) ib = 8
+          IF ( TRIM( variable(6:) ) == '9' ) ib = 9
+          IF ( TRIM( variable(6:) ) == '10' ) ib = 10
+          IF ( TRIM( variable(6:) ) == '11' ) ib = 11
+          IF ( TRIM( variable(6:) ) == '12' ) ib = 12
+
           IF ( av == 0 )  THEN
-             IF ( .NOT. mask_surface(mid) )  THEN   
+             IF ( .NOT. mask_surface(mid) )  THEN
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = aerosol_number(b)%conc( mask_k(mid,k),&
-                                                                   mask_j(mid,j),&
-                                                                   mask_i(mid,i) )
+                         local_pf(i,j,k) = aerosol_number(ib)%conc( mask_k(mid,k), mask_j(mid,j),  &
+                                                                    mask_i(mid,i) )
                       ENDDO
                    ENDDO
                 ENDDO
-             ELSE 
+             ELSE
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
-                                                                  mask_i(mid,i),&
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
                                                                   grid )
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = aerosol_number(b)%conc(             &
-                                           MIN( topo_top_ind+mask_k(mid,k),    &
-                                                nzt+1 ),                 &
-                                           mask_j(mid,j), mask_i(mid,i) )
+                         local_pf(i,j,k) = aerosol_number(ib)%conc(MIN( topo_top_ind+mask_k(mid,k),&
+                                                                        nzt+1 ),                   &
+                                                                   mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
                    ENDDO
@@ -10039,7 +10291,7 @@
              resorted = .TRUE.
           ELSE
-             to_be_resorted => Nbins_av(:,:,:,b)
+             to_be_resorted => nbins_av(:,:,:,ib)
           ENDIF
-          
+
        CASE ( 'Ntot' )
           IF ( av == 0 )  THEN
@@ -10048,6 +10300,6 @@
                    DO  k = nzb, nz_do3d
                       temp_bin = 0.0_wp
-                      DO  b = 1, nbins
-                         temp_bin = temp_bin + aerosol_number(b)%conc(k,j,i)
+                      DO  ib = 1, nbins_aerosol
+                         temp_bin = temp_bin + aerosol_number(ib)%conc(k,j,i)
                       ENDDO
                       tend(k,j,i) = temp_bin
@@ -10059,6 +10311,5 @@
                    DO  j = 1, mask_size_l(mid,2)
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
-                                                 mask_i(mid,i) )
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
                    ENDDO
@@ -10067,10 +10318,8 @@
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
-                                                                  mask_i(mid,i),&
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
                                                                   grid )
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
-                                                      nzt+1 ),                 &
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
                                                  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
@@ -10080,22 +10329,22 @@
              resorted = .TRUE.
           ELSE
-             to_be_resorted => Ntot_av
+             to_be_resorted => ntot_av
           ENDIF
-          
-       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4',   'm_bin5',  'm_bin6',   &
-              'm_bin7', 'm_bin8', 'm_bin9', 'm_bin10' , 'm_bin11', 'm_bin12' )
-          IF ( TRIM( variable(6:) ) == '1' ) b = 1
-          IF ( TRIM( variable(6:) ) == '2' ) b = 2
-          IF ( TRIM( variable(6:) ) == '3' ) b = 3
-          IF ( TRIM( variable(6:) ) == '4' ) b = 4
-          IF ( TRIM( variable(6:) ) == '5' ) b = 5
-          IF ( TRIM( variable(6:) ) == '6' ) b = 6
-          IF ( TRIM( variable(6:) ) == '7' ) b = 7
-          IF ( TRIM( variable(6:) ) == '8' ) b = 8
-          IF ( TRIM( variable(6:) ) == '9' ) b = 9
-          IF ( TRIM( variable(6:) ) == '10' ) b = 10
-          IF ( TRIM( variable(6:) ) == '11' ) b = 11
-          IF ( TRIM( variable(6:) ) == '12' ) b = 12
-          
+
+       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',      &
+              'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
+          IF ( TRIM( variable(6:) ) == '1' ) ib = 1
+          IF ( TRIM( variable(6:) ) == '2' ) ib = 2
+          IF ( TRIM( variable(6:) ) == '3' ) ib = 3
+          IF ( TRIM( variable(6:) ) == '4' ) ib = 4
+          IF ( TRIM( variable(6:) ) == '5' ) ib = 5
+          IF ( TRIM( variable(6:) ) == '6' ) ib = 6
+          IF ( TRIM( variable(6:) ) == '7' ) ib = 7
+          IF ( TRIM( variable(6:) ) == '8' ) ib = 8
+          IF ( TRIM( variable(6:) ) == '9' ) ib = 9
+          IF ( TRIM( variable(6:) ) == '10' ) ib = 10
+          IF ( TRIM( variable(6:) ) == '11' ) ib = 11
+          IF ( TRIM( variable(6:) ) == '12' ) ib = 12
+
           IF ( av == 0 )  THEN
              DO  i = nxl, nxr
@@ -10103,17 +10352,16 @@
                    DO  k = nzb, nz_do3d
                       temp_bin = 0.0_wp
-                      DO  c = b, ncc_tot*nbins, nbins
-                         temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                      DO  ic = ib, ncomponents_mass * nbins_aerosol, nbins_aerosol
+                         temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                       ENDDO
                       tend(k,j,i) = temp_bin
                    ENDDO
                 ENDDO
-             ENDDO   
-             IF ( .NOT. mask_surface(mid) )  THEN   
+             ENDDO
+             IF ( .NOT. mask_surface(mid) )  THEN
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
-                                                 mask_i(mid,i) )
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
                    ENDDO
@@ -10122,10 +10370,8 @@
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
-                                                                  mask_i(mid,i),&
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
                                                                   grid )
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
-                                                      nzt+1 ),                 &
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
                                                  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
@@ -10135,7 +10381,7 @@
              resorted = .TRUE.
           ELSE
-             to_be_resorted => mbins_av(:,:,:,b)
+             to_be_resorted => mbins_av(:,:,:,ib)
           ENDIF
-       
+
        CASE ( 'PM2.5' )
           IF ( av == 0 )  THEN
@@ -10144,8 +10390,8 @@
                    DO  k = nzb, nz_do3d
                       temp_bin = 0.0_wp
-                      DO  b = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 2.5E-6_wp )  THEN
-                            DO  c = b, nbins * ncc, nbins
-                               temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                      DO  ib = 1, nbins_aerosol
+                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
+                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                             ENDDO
                          ENDIF
@@ -10155,10 +10401,9 @@
                 ENDDO
              ENDDO 
-             IF ( .NOT. mask_surface(mid) )  THEN   
+             IF ( .NOT. mask_surface(mid) )  THEN
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
-                                                 mask_i(mid,i) )
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
                    ENDDO
@@ -10167,10 +10412,8 @@
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
-                                                                  mask_i(mid,i),&
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
                                                                   grid )
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
-                                                      nzt+1 ),                 &
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
                                                  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
@@ -10180,7 +10423,7 @@
              resorted = .TRUE.
           ELSE
-             to_be_resorted => PM25_av
+             to_be_resorted => pm25_av
           ENDIF
-          
+
        CASE ( 'PM10' )
           IF ( av == 0 )  THEN
@@ -10189,8 +10432,8 @@
                    DO  k = nzb, nz_do3d
                       temp_bin = 0.0_wp
-                      DO  b = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 10.0E-6_wp )  THEN
-                            DO  c = b, nbins * ncc, nbins
-                               temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                      DO  ib = 1, nbins_aerosol
+                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
+                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                             ENDDO
                          ENDIF
@@ -10200,10 +10443,9 @@
                 ENDDO
              ENDDO 
-             IF ( .NOT. mask_surface(mid) )  THEN   
+             IF ( .NOT. mask_surface(mid) )  THEN
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j),&
-                                                 mask_i(mid,i) )
+                         local_pf(i,j,k) = tend( mask_k(mid,k),  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
                    ENDDO
@@ -10212,10 +10454,8 @@
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
-                                                                  mask_i(mid,i),&
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
                                                                   grid )
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
-                                                      nzt+1 ),                 &
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
                                                  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
@@ -10225,17 +10465,17 @@
              resorted = .TRUE.
           ELSE
-             to_be_resorted => PM10_av
+             to_be_resorted => pm10_av
           ENDIF
-          
+
        CASE ( 's_BC', 's_DU', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
           IF ( av == 0 )  THEN
              IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
-                icc = get_index( prtcl, TRIM( variable(3:) ) )
+                found_index = get_index( prtcl, TRIM( variable(3:) ) )
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
                       DO  k = nzb, nz_do3d
                          temp_bin = 0.0_wp
-                         DO  c = ( icc-1 )*nbins+1, icc*nbins 
-                            temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                         DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
+                            temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                          ENDDO
                          tend(k,j,i) = temp_bin
@@ -10246,22 +10486,19 @@
                 tend = 0.0_wp
              ENDIF
-             IF ( .NOT. mask_surface(mid) )  THEN   
+             IF ( .NOT. mask_surface(mid) )  THEN
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( mask_k(mid,k), mask_j(mid,j), &
-                                                 mask_i(mid,i) )
+                         local_pf(i,j,k) = tend( mask_k(mid,k), mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
                    ENDDO
                 ENDDO
-             ELSE      
+             ELSE
                 DO  i = 1, mask_size_l(mid,1)
                    DO  j = 1, mask_size_l(mid,2)
-                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),&
-                                                                  mask_i(mid,i),&
+                      topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i),    &
                                                                   grid )
                       DO  k = 1, mask_size_l(mid,3)
-                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k),&
-                                                      nzt+1 ),&
+                         local_pf(i,j,k) = tend( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),         &
                                                  mask_j(mid,j), mask_i(mid,i) )
                       ENDDO
@@ -10271,28 +10508,26 @@
              resorted = .TRUE.
           ELSE
-             IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_BC_av
-             IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_DU_av   
-             IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_NH_av   
-             IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_NO_av   
-             IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_OC_av   
-             IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_SO4_av   
-             IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_SS_av
+             IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_bc_av
+             IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_du_av
+             IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_nh_av
+             IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_no_av
+             IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_oc_av
+             IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_so4_av
+             IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_ss_av
           ENDIF
-       
+
        CASE DEFAULT
           found = .FALSE.
-    
+
     END SELECT
-    
-    
+
     IF ( .NOT. resorted )  THEN
        IF ( .NOT. mask_surface(mid) )  THEN
 !
-!--       Default masked output    
+!--       Default masked output
           DO  i = 1, mask_size_l(mid,1)
              DO  j = 1, mask_size_l(mid,2)
                 DO  k = 1, mask_size_l(mid,3)
-                   local_pf(i,j,k) = to_be_resorted( mask_k(mid,k),            &
-                                                     mask_j(mid,j),mask_i(mid,i) )
+                   local_pf(i,j,k) = to_be_resorted( mask_k(mid,k), mask_j(mid,j),mask_i(mid,i) )
                 ENDDO
              ENDDO
@@ -10300,16 +10535,14 @@
        ELSE
 !
-!--       Terrain-following masked output      
+!--       Terrain-following masked output
           DO  i = 1, mask_size_l(mid,1)
              DO  j = 1, mask_size_l(mid,2)
 !
 !--             Get k index of highest horizontal surface
-                topo_top_ind = get_topography_top_index_ji( mask_j(mid,j),     &
-                                                            mask_i(mid,i), grid )
+                topo_top_ind = get_topography_top_index_ji( mask_j(mid,j), mask_i(mid,i), grid )
 !
 !--             Save output array
                 DO  k = 1, mask_size_l(mid,3)
-                   local_pf(i,j,k) = to_be_resorted( MIN( topo_top_ind+mask_k(mid,k),&
-                                                          nzt+1 ),             &
+                   local_pf(i,j,k) = to_be_resorted( MIN( topo_top_ind+mask_k(mid,k), nzt+1 ),     &
                                                      mask_j(mid,j), mask_i(mid,i) )
                 ENDDO
@@ -10318,7 +10551,6 @@
        ENDIF
     ENDIF
-    
+
  END SUBROUTINE salsa_data_output_mask
- 
 
  END MODULE salsa_mod
